# Copyright 2022 Jij Inc.

# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at

#     http://www.apache.org/licenses/LICENSE-2.0

# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from __future__ import annotations

import cimod.cxxcimod, dimod

from dimod import BINARY as _BINARY, SPIN as _SPIN, Vartype as _Vartype

SPIN = _SPIN
BINARY = _BINARY
Vartype = _Vartype


def to_cxxcimod(vartype):
    # convert to cxxcimod type
    if isinstance(vartype, cimod.cxxcimod.Vartype):
        return vartype

    vartype = dimod.as_vartype(vartype)
    if vartype == SPIN:
        return cimod.cxxcimod.Vartype.SPIN
    if vartype == BINARY:
        return cimod.cxxcimod.Vartype.BINARY
